import pygame
import gamestate
import cell
import sign
import pygame
from pygame.locals import *

from pgu import gui

class ComponentWindow(gui.Table):
    def __init__(self, gstate):
        gui.Table.__init__(self)
        self.gstate = gstate
        self.style.width = 200
        self.cell = None
        self.signimage = gui.Image("../media/iconlight.png") #Example
        self.signinfo = {}

        self.signinfo["location"] = gui.Label("",align=-0.8)
        self.signinfo["activated"] = gui.Label("", align=-0.8)
        self.signinfo["location"].style.width = self.signinfo["activated"].style.width = 100
        self.signinfo["red"] = gui.Label("    ")
        self.signinfo["green"] = gui.Label("    ")
        
        self.removebutton = gui.Button("Remove",disabled=True,height=25)
        self.removebutton.connect(gui.CLICK, self.gstate.removeSign)
        self.configurebutton = gui.Button("Configure",disabled=True,height=25)
        self.configurebutton.connect(gui.CLICK, self.gstate.openDialog, self.gstate.controldialog)
        self.windowSetup()

    def windowSetup(self):
        imgcontainer = gui.Container(width=2*self.style.width/5,height=200, background=(255,255,255))
        infotable = gui.Table(width=3*self.style.width/5,height=200, background=(235,235,235))
        
        fontBig = pygame.font.SysFont("default", 25, True)
        infotable.tr()
        infotable.td(gui.Label("Status", font=fontBig), height=25)
        infotable.tr()
        infotable.td(gui.Label("Location:", color=(0,0,255)), align=-1)
        infotable.tr()
        infotable.td(self.signinfo["location"])
        infotable.tr()
        infotable.td(gui.Label("Status:", color=(0,0,255)), align=-1)
        infotable.tr()
        infotable.td(self.signinfo["activated"])
        infotable.tr()
        infotable.td(self.removebutton, align=-0.8, valign = 1, height=40)
        infotable.tr()
        infotable.td(self.configurebutton, align=-0.8, height=40)

        interval_table = gui.Table(width=200,height=50, background=(235,235,235))
        interval_table.tr()
        interval_table.td(gui.Label("Red:", color=(255,0,0)), align=-1)
        interval_table.tr()
        interval_table.td(self.signinfo["red"])
        interval_table.tr()
        interval_table.td(gui.Label("Green:", color=(0,255,0)), align=-1)
        interval_table.tr()
        interval_table.td(self.signinfo["green"])
        
        imgcontainer.add(self.signimage, 0, 10)
        self.tr()
        self.td(gui.Label("Traffic Sign",font=fontBig,color=(255,255,255)),
                height=30, background=(0,0,51),colspan=2)
        self.tr()
        self.td(imgcontainer)
        self.td(infotable)
        self.tr()
        self.td(gui.Label("Time Interval",font=fontBig,color=(255,255,255)),
                height=30, background=(0,0,51),colspan=2)
        self.tr()
        self.td(interval_table,colspan=2)  
        
    def storeSignInfo(self, cell):
        print "Assigns signimage and signinfo based on the given parameter"
        self.cell = cell
        self.removebutton.disabled = False
        self.configurebutton.disabled = False
        self.repaint()
    
    def repaint(self):
        sign = self.cell.sign
        if (not sign==None):
            self.signinfo["activated"].value = "Activated"
            self.signinfo["red"].value = str(self.cell.sign.redTime)
            self.signinfo["green"].value = str(self.cell.sign.greenTime)
        else:
            self.signinfo["activated"].value = "Unactivated"
        gui.Table.repaint(self)
