""" This file contains global variables, shared functions, and constants """
import pygame
import gamestate
import mainmenu
import selectlevel
from pygame.locals import *
#Global
screen = None

map = None

"""
number displayed on the bottom left for number of vehicles that are currently time-out
"""

timeoutAllowed = 0
timeoutCount = 0
numTimeout = None

""" COLORS"""
#ROADS
noneColor = (143,255,105)
blockColor = (150,150,150)
busyColor = (97,97,97)
notBusyColor = (176,176,176)
iBusyColor = (120,120,120)
iNotBusyColor = (200,200,200)
#LIGHT
red = (255,0,0)
green = (0,255,0)
#CARS
carColor = (0,0,0)
timeOutColor = (51, 51, 102)
crashColor = red

""" FONTS """
pygame.font.init()
labelFont = pygame.font.SysFont("default", 15, True)
statusFont = pygame.font.SysFont("Courier", 14)

"""
Functions
"""
""" Transitions to Main Menu """
def toMainMenu(origin):
    newMainMenu = mainmenu.MainMenu(screen)
    origin.quit()
    newMainMenu.start()

""" Transitions to Select Level mode """
def toSelectLevel(origin):
    newSelectLevel = selectlevel.SelectLevel(screen)
    origin.quit()
    newSelectLevel.start()

""" Transitions to Game State mode """
def toGameState(origin, inputfile=None):
    newGameState = gamestate.GameState(screen,inputfile=inputfile)
    origin.quit()
    newGameState.start()

    
    
    
    
