import pygame
from pygame.locals import *
from pgu import gui

#Automatically keeps the LogWindow scrolled at the bottom. Code reference: pgu example, gui17.py
class Scroller(gui.Spacer):
    def __init__(self,logw,**params):
        gui.Spacer.__init__(self,**params)
        self.logw = logw
        
    def resize(self,width=None,height=None):
        self.logw.set_vertical_scroll(50000)
        return 1,1  
        
class LogWindow(gui.ScrollArea):
    def __init__(self, width=300,height=110):
        # Where the info is stored
        self.log = gui.Table()
        gui.ScrollArea.__init__(self, self.log, width,height,False)
        
        self.log.td(Scroller(self,width=1,height=1))

    def storeInfo(self, info):
        self.log.tr()
        logFont = pygame.font.SysFont("Courier New,Courier", 14)
        self.log.td(gui.Label(info,font=logFont),align=-1)

    
