import pygame
import gamestate
import mainmenu
import statescreen
import const
from pygame.locals import *
from pgu import gui

class SelectLevel(statescreen.StateScreen):
    def __init__(self, screen, bgcolor=(255,255,255),**params):
        statescreen.StateScreen.__init__(self, screen, bgcolor,**params)
        
        self.mapselector = MapSelector()
        self.selectedmap = 0    #index (int) of map that's clicked by the user
        self.startbutton = gui.Image("../media/startgame.jpg")
        self.backbutton = gui.Image("../media/back.png")
        self.mapimage = gui.Image("../media/map0.png")      #gui.Image
        
        #Dimensions of the screen
        screenWidth = self.screen.get_width()
        screenHeight = self.screen.get_height()

        #Handling button events and putting buttons to the main container (cont)
        self.backbutton.connect(gui.CLICK,const.toMainMenu, self)
        self.cont.add(self.mapselector, (screenWidth - self.mapselector.style.width)/2, screenHeight/10)
        self.addCustomizedButton(self.startbutton,(screenWidth - self.startbutton.style.width)/2,screenHeight*5/6)
        self.startbutton.connect(gui.CLICK,const.toGameState, self)
        self.cont.add(self.backbutton, 15,(screenHeight - self.backbutton.style.height - 15))
        self.cont.add(self.mapimage, (screenWidth - 300)/2, 185)
        titleFont = pygame.font.SysFont("Garamond", 35, True)
        titleLabel = gui.Label("Select a Difficulty Level", font=titleFont)
        self.cont.add(titleLabel, (self.screen.get_width()-titleLabel.style.width)/2, 10)

class MapSelector(gui.Container):
    def __init__(self,**params):
        gui.Container.__init__(self,**params)
        self.range = None          #current level ranges viewed by user
        self.selectedmap = None    #index of map that's clicked by the user
        self.maplevels = None      
        self.leftarrow = gui.Image("../media/left.png")
        self.leftarrow.connect(gui.CLICK,self.previousRange)
        self.rightarrow = gui.Image("../media/right.png")
        self.rightarrow.connect(gui.CLICK,self.nextRange)
        self.style.width = 800
        self.style.height = 200
        self.add(self.leftarrow,0,0)
        self.add(self.rightarrow,self.style.width-self.rightarrow.style.width,0)
    
    def nextRange(self):
        print "Test right button"
        self.range = None  #moves to the next level range when right arrow is clicked

    def previousRange(self):
        print "Test left button"
        self.range = None  #moves to the previous level range when left arrow is clicked

