import pygame
from pygame.locals import *
from pgu import gui

""" A class representing the three states. Thus, MainMenu, SelectLevel, and GameState extends this class """
class StateScreen(gui.App):
    def __init__(self,screen,bgcolor=(255,255,255),**params):
        gui.App.__init__(self,**params)
        self.connect(gui.QUIT,self.quit,None)
        self.screen = screen
        
        #Container
        self.cont = gui.Container(width=screen.get_width(),height=screen.get_height(),background=bgcolor)

    """ Customize a button and put in on the main container """
    def addCustomizedButton(self,button, x,y):
        button.connect(gui.ENTER, self.hoveredButton, button, y+button.style.height/2)
        button.connect(gui.EXIT, self.leftButton)
        self.cont.add(button,x,y)

    """ Customize a hovered button """    
    def hoveredButton(self, button,y):
        pygame.draw.line(self.screen,(0,0,0),(0,y-1),(self.screen.get_width(),y-1),4)
        button.repaint()
        pygame.display.flip()

    """ Clear the hover effects mouse cursor leaves a customized button"""      
    def leftButton(self):
        self.cont.repaint()
        pygame.display.flip()

    """ Start this screen/state """
    def start(self):
        self.run(self.cont,self.screen)
    
        
