import sys
sys.path.append('../src')
import pygame
import unittest
import sign
import cell
import gamestate
import map
import statescreen


class TestSystem(unittest.TestCase):

    def setUp(self):
        screen = pygame.display.set_mode((800,600))
        self.state = gamestate.GameState(screen,bgcolor=(0,0,0), inputfile='test.txt')
        self.trafficLight = sign.TrafficLight(10, 10) #pass random value for redlight and greenlight


    def testPlacingTrafficLight(self):
        testCell = cell.IntersectionCell(9, 11, False, False, False, False)
        testCell.setTrafficSign(5,10, (10,11))
        testSign = testCell.getSign
        self.assertTrue(testSign, "Sign at these intersection cell should not be None or NULL")



if __name__ == '__main__':
    
    suite = unittest.TestLoader().loadTestsFromTestCase(TestSystem)

    unittest.TextTestRunner(verbosity=2).run(suite)

