import sys
sys.path.append('../src')
import pygame
import unittest
import map
import cell

# Dummy Vehicle Class
class Vehicle():
    def __init__(self):
        self.isWaiting = False

    # Set the vehicle's waiting status
    def setWaiting( self, waiting ):
        self.isWaiting = waiting
    
    def updateVehicle( self ):
        pass
        
# Dummy Cell Class
class Cell():
    def __init__(self):
        self.countCell = 0

    def updateCell( self ):
        pass


class TestMapFunctions(unittest.TestCase):
    # Set up elements needed for testing map - updateMap in particular
    def setUp(self):

        # Create cells
        cells=[]
        for i in range(10):
            cells.append([])
            for j in range(10):
                cells[i].append(Cell())
        vehicles = []
        # Create the map
        self.myMap = map.Map(cells, vehicles)
        # Create cars and plug it into the map
        for i in range(20):
            self.myMap.cars.append(Vehicle())


    # Test update
    def testupdateMap(self):
        self.myMap.updateMap()


if __name__ == '__main__':
    suite = unittest.TestLoader().loadTestsFromTestCase(TestMapFunctions)
    unittest.TextTestRunner(verbosity=2).run(suite)