import sys
sys.path.append('../src')
import pygame
import unittest
import sign

# Dummy Vehicle Class
class Vehicle():
    def __init__(self):
        self.isWaiting = False

    # Set the vehicle's waiting status
    def setWaiting( self, waiting ):
        self.isWaiting = waiting


class TestStopSignFunctions(unittest.TestCase):
    # Set up elements needed for testing sign
    def setUp(self):
        # Create a new stop sign object
        self.mySign = sign.StopSign()

        # Create a new vehicle to be tested
        self.myVeh = Vehicle()

    # Test handleVehicle
    def testhandleVehicle(self):
        # Vehicle's isWaiting should be true
        self.mySign.handleVehicle(self.myVeh)

        # Create clock to test stop sign
        clock = pygame.time.Clock()
        clock.tick()
        stopTimer = 0
        
        # Boolean to check if the vehicle is in waiting condition
        checkWait1 = False
        checkWait2 = False
        checkWait3 = False

        while(true):
            stopTimer += clock.tick()
            # If car hasn't stop for more than 2 seconds
            if( stopTimer > 400 and stopTimer < 800 and checkWait1 == False ):
                self.assertTrue(self.myVeh.isWaiting, "Vechicle's isWaiting should be True")
                checkWait1 = True
            if( stopTimer > 400 and stopTimer < 800 and checkWait2 == False ):
                self.assertTrue(self.myVeh.isWaiting, "Vechicle's isWaiting should be True")
                checkWait2 = True
            if( stopTimer > 400 and stopTimer < 800 and checkWait3 == False ):
                self.assertTrue(self.myVeh.isWaiting, "Vechicle's isWaiting should be True")
                checkWait3 = True
            if( stopTimer > 2000 ):
                break
        # After 2 seconds, the vehicle should not be waiting anymore
        self.assertFalse(self.myVeh.isWaiting, "Vehicle's isWaiting should be False")
        

if __name__ == '__main__':
    suite = unittest.TestLoader().loadTestsFromTestCase(TestSignFunctions)
    unittest.TextTestRunner(verbosity=2).run(suite)